import { getEndpointPlugin } from "@smithy/middleware-endpoint";
import { getSerdePlugin } from "@smithy/middleware-serde";
import { Command as $Command } from "@smithy/smithy-client";
import { commonParams } from "../endpoint/EndpointParameters";
import { de_DescribeAccountAttributesCommand, se_DescribeAccountAttributesCommand } from "../protocols/Aws_json1_1";
export { $Command };
export class DescribeAccountAttributesCommand extends $Command
    .classBuilder()
    .ep({
    ...commonParams,
})
    .m(function (Command, cs, config, o) {
    return [
        getSerdePlugin(config, this.serialize, this.deserialize),
        getEndpointPlugin(config, Command.getEndpointParameterInstructions()),
    ];
})
    .s("AmazonDMSv20160101", "DescribeAccountAttributes", {})
    .n("DatabaseMigrationServiceClient", "DescribeAccountAttributesCommand")
    .f(void 0, void 0)
    .ser(se_DescribeAccountAttributesCommand)
    .de(de_DescribeAccountAttributesCommand)
    .build() {
}
