import { getEndpointPlugin } from "@smithy/middleware-endpoint";
import { getSerdePlugin } from "@smithy/middleware-serde";
import { Command as $Command } from "@smithy/smithy-client";
import { commonParams } from "../endpoint/EndpointParameters";
import { de_DescribeDataProvidersCommand, se_DescribeDataProvidersCommand } from "../protocols/Aws_json1_1";
export { $Command };
export class DescribeDataProvidersCommand extends $Command
    .classBuilder()
    .ep({
    ...commonParams,
})
    .m(function (Command, cs, config, o) {
    return [
        getSerdePlugin(config, this.serialize, this.deserialize),
        getEndpointPlugin(config, Command.getEndpointParameterInstructions()),
    ];
})
    .s("AmazonDMSv20160101", "DescribeDataProviders", {})
    .n("DatabaseMigrationServiceClient", "DescribeDataProvidersCommand")
    .f(void 0, void 0)
    .ser(se_DescribeDataProvidersCommand)
    .de(de_DescribeDataProvidersCommand)
    .build() {
}
