import { getEndpointPlugin } from "@smithy/middleware-endpoint";
import { getSerdePlugin } from "@smithy/middleware-serde";
import { Command as $Command } from "@smithy/smithy-client";
import { commonParams } from "../endpoint/EndpointParameters";
import { de_ModifyReplicationConfigCommand, se_ModifyReplicationConfigCommand } from "../protocols/Aws_json1_1";
export { $Command };
export class ModifyReplicationConfigCommand extends $Command
    .classBuilder()
    .ep({
    ...commonParams,
})
    .m(function (Command, cs, config, o) {
    return [
        getSerdePlugin(config, this.serialize, this.deserialize),
        getEndpointPlugin(config, Command.getEndpointParameterInstructions()),
    ];
})
    .s("AmazonDMSv20160101", "ModifyReplicationConfig", {})
    .n("DatabaseMigrationServiceClient", "ModifyReplicationConfigCommand")
    .f(void 0, void 0)
    .ser(se_ModifyReplicationConfigCommand)
    .de(de_ModifyReplicationConfigCommand)
    .build() {
}
