import { SENSITIVE_STRING } from "@smithy/smithy-client";
import { DatabaseMigrationServiceServiceException as __BaseException } from "./DatabaseMigrationServiceServiceException";
import { DocDbSettingsFilterSensitiveLog, EndpointFilterSensitiveLog, GcpMySQLSettingsFilterSensitiveLog, IBMDb2SettingsFilterSensitiveLog, KafkaSettingsFilterSensitiveLog, MicrosoftSQLServerSettingsFilterSensitiveLog, MongoDbSettingsFilterSensitiveLog, MySQLSettingsFilterSensitiveLog, OracleSettingsFilterSensitiveLog, PostgreSQLSettingsFilterSensitiveLog, RedisSettingsFilterSensitiveLog, RedshiftSettingsFilterSensitiveLog, SybaseSettingsFilterSensitiveLog, } from "./models_0";
export class UpgradeDependencyFailureFault extends __BaseException {
    constructor(opts) {
        super({
            name: "UpgradeDependencyFailureFault",
            $fault: "client",
            ...opts,
        });
        this.name = "UpgradeDependencyFailureFault";
        this.$fault = "client";
        Object.setPrototypeOf(this, UpgradeDependencyFailureFault.prototype);
    }
}
export class SubnetAlreadyInUse extends __BaseException {
    constructor(opts) {
        super({
            name: "SubnetAlreadyInUse",
            $fault: "client",
            ...opts,
        });
        this.name = "SubnetAlreadyInUse";
        this.$fault = "client";
        Object.setPrototypeOf(this, SubnetAlreadyInUse.prototype);
    }
}
export const ReloadOptionValue = {
    DATA_RELOAD: "data-reload",
    VALIDATE_ONLY: "validate-only",
};
export const OriginTypeValue = {
    SOURCE: "SOURCE",
    TARGET: "TARGET",
};
export const StartReplicationTaskTypeValue = {
    RELOAD_TARGET: "reload-target",
    RESUME_PROCESSING: "resume-processing",
    START_REPLICATION: "start-replication",
};
export class KMSFault extends __BaseException {
    constructor(opts) {
        super({
            name: "KMSFault",
            $fault: "client",
            ...opts,
        });
        this.name = "KMSFault";
        this.$fault = "client";
        Object.setPrototypeOf(this, KMSFault.prototype);
    }
}
export const ModifyEndpointMessageFilterSensitiveLog = (obj) => ({
    ...obj,
    ...(obj.Password && { Password: SENSITIVE_STRING }),
    ...(obj.MongoDbSettings && { MongoDbSettings: MongoDbSettingsFilterSensitiveLog(obj.MongoDbSettings) }),
    ...(obj.KafkaSettings && { KafkaSettings: KafkaSettingsFilterSensitiveLog(obj.KafkaSettings) }),
    ...(obj.RedshiftSettings && { RedshiftSettings: RedshiftSettingsFilterSensitiveLog(obj.RedshiftSettings) }),
    ...(obj.PostgreSQLSettings && { PostgreSQLSettings: PostgreSQLSettingsFilterSensitiveLog(obj.PostgreSQLSettings) }),
    ...(obj.MySQLSettings && { MySQLSettings: MySQLSettingsFilterSensitiveLog(obj.MySQLSettings) }),
    ...(obj.OracleSettings && { OracleSettings: OracleSettingsFilterSensitiveLog(obj.OracleSettings) }),
    ...(obj.SybaseSettings && { SybaseSettings: SybaseSettingsFilterSensitiveLog(obj.SybaseSettings) }),
    ...(obj.MicrosoftSQLServerSettings && {
        MicrosoftSQLServerSettings: MicrosoftSQLServerSettingsFilterSensitiveLog(obj.MicrosoftSQLServerSettings),
    }),
    ...(obj.IBMDb2Settings && { IBMDb2Settings: IBMDb2SettingsFilterSensitiveLog(obj.IBMDb2Settings) }),
    ...(obj.DocDbSettings && { DocDbSettings: DocDbSettingsFilterSensitiveLog(obj.DocDbSettings) }),
    ...(obj.RedisSettings && { RedisSettings: RedisSettingsFilterSensitiveLog(obj.RedisSettings) }),
    ...(obj.GcpMySQLSettings && { GcpMySQLSettings: GcpMySQLSettingsFilterSensitiveLog(obj.GcpMySQLSettings) }),
});
export const ModifyEndpointResponseFilterSensitiveLog = (obj) => ({
    ...obj,
    ...(obj.Endpoint && { Endpoint: EndpointFilterSensitiveLog(obj.Endpoint) }),
});
